unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Tlhelp32;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//Esta rotina fecha o programa desejado
function KillTask(ExeFileName: string): Integer;
const
   PROCESS_TERMINATE = $0001;
var
   ContinueLoop: BOOL;
   FSnapshotHandle: THandle;
   FProcessEntry32: TProcessEntry32;
begin
   Result := 0;
   FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
   FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
   ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);

   while Integer(ContinueLoop) <> 0 do
   begin
   if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
   UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
   UpperCase(ExeFileName))) then
   Result := Integer(TerminateProcess(
   OpenProcess(PROCESS_TERMINATE,
   BOOL(0),
   FProcessEntry32.th32ProcessID),0));
   ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
   end;
   CloseHandle(FSnapshotHandle);
end;

//Esta rotina verifica o programa desejado
function IsFileInUse(FileName: TFileName): Boolean;
var
   HFileRes: HFILE;
begin
   Result := False;
   if not FileExists(FileName) then Exit;
   HFileRes := CreateFile(PChar(FileName),GENERIC_READ or GENERIC_WRITE,0,
   nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   Result := (HFileRes = INVALID_HANDLE_VALUE);
   if not Result then
   CloseHandle(HFileRes);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   //Substitua o endereo 'C:\Windows\NOTEPAD.exe' pelo seu programa
   if IsFileInUse('C:\Windows\NOTEPAD.exe') then//Verifica se o programa est aberto
   begin

   case application.MessageBox('O Programa est em uso. Deseja fech-lo?', 'Ateno',mb_yesno + MB_ICONQUESTION ) of
   idyes : begin
   KillTask('NOTEPAD.exe');//Fecha o programa
   ShowMessage('O Programa foi fechado com sucesso!');
   end;
   idno : begin
   //Close;
   end;
   end;

   end else begin
   ShowMessage('O Programa no est em uso.');
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   Close;
end;

end.
